/*
  Library support for FlexRadio 6000 Rigs
  Copyright (C)2015 Vincenzo Stefanazzi - IW7DMH. All right reserved

  This library is free software; you can redistribute it and/or
  modify it under the terms of the CC BY-NC-SA 3.0 license.
  https://creativecommons.org/licenses/by-nc-sa/3.0/
  
  The license applies to all part of the library including the 
  examples and tools supplied with the library.
*/
#include "Waterfall.h"

Waterfall::Waterfall() {
	updated=false;
}


void Waterfall::updateStatus(String msg) {
	//Serial.println(msg);
	updated=true;
	int oldi=0;
	int i=msg.indexOf(' ',oldi);
	while (i>0) {
		setValue(msg.substring(oldi,i));
		oldi=i+1;
		i=msg.indexOf(' ',oldi+1);
	}	
	//get the last element
	i=msg.indexOf('\n',oldi);
	setValue(msg.substring(oldi,i));
	/*
	Serial.println(waterfall);
	Serial.println(x_pixels);
	Serial.println(center);
	Serial.println(bandwidth);
	Serial.println(line_duration);
	Serial.println(rfgain);
	Serial.println(rxant);
	Serial.println(wide); 
	Serial.println(loopa);
	Serial.println(loopb);
	Serial.println(band);
	Serial.println(daxiq);
	Serial.println(daxiq_rate);
	Serial.println(capacity);
	Serial.println(available);
	Serial.println(panadapter);
	Serial.println(color_gain);
	Serial.println(auto_black);
	Serial.println(black_level);
	Serial.println(gradient_index);
	Serial.println(xvtr);
	*/
}

void Waterfall::setValue(String msg){
	int i=msg.indexOf('=');
	if (i>0) {
	    String var=msg.substring(0,i);
		//Serial.println(var);
		
		//if (var.equals("waterfall")) { waterfall=msg.substring(i+1).toInt(); return; }
		if (var.equals("x_pixels")) { x_pixels=msg.substring(i+1).toInt(); return; }
		if (var.equals("center")) { center=msg.substring(i+1).toFloat()*1000000; return; }
		if (var.equals("bandwidth")) { bandwidth=msg.substring(i+1).toFloat()*1000000; return; }
		if (var.equals("line_duration")) { line_duration=msg.substring(i+1).toInt(); return; }
		if (var.equals("rfgain")) { rfgain=msg.substring(i+1).toInt(); return; }
		if (var.equals("rxant")) { rxant=msg.substring(i+1); return; }
		if (var.equals("wide")) { wide=msg.substring(i+1).toInt(); return; }
		if (var.equals("loopa")) { loopa=msg.substring(i+1).toInt(); return; }
		if (var.equals("loopb")) { loopb=msg.substring(i+1).toInt(); return; }
		if (var.equals("band")) { band=msg.substring(i+1).toInt(); return; }
		if (var.equals("daxiq")) { daxiq=msg.substring(i+1).toInt(); return; }
		if (var.equals("daxiq_rate")) { daxiq_rate=msg.substring(i+1).toInt(); return; }
		if (var.equals("capacity")) { capacity=msg.substring(i+1).toInt(); return; }
		if (var.equals("available")) { available=msg.substring(i+1).toInt(); return; }
		if (var.equals("panadapter")) { panadapter=msg.substring(i+1).toInt(); return; }  //IT IS HEX value indeed!!!
		if (var.equals("color_gain")) { color_gain=msg.substring(i+1).toInt(); return; }
		if (var.equals("auto_black")) { auto_black=msg.substring(i+1).toInt(); return; }
		if (var.equals("black_level")) { black_level=msg.substring(i+1).toInt(); return; }
		if (var.equals("gradient_index")) { gradient_index=msg.substring(i+1).toInt(); return; }
		if (var.equals("xvtr")) { xvtr=msg.substring(i+1).toInt(); return; }


	}
}

void Waterfall::updateObject(int objectId,int value){
	switch(objectId) {
 		case WATERFALL_BLACK_LEVEL:
		    black_level=value;
			break;
		case WATERFALL_GRADIENT_INDEX:
		    gradient_index=value;
			break;
		case WATERFALL_LINE_DURATION:
		    line_duration=value;
			break;
		case WATERFALL_COLOR_GAIN:
		    color_gain=value;
			break;
		default:
			 Serial.print("Waterfall::updateObject - Unhandled id:"); Serial.println(objectId);
	}

}